//
// ********************************************************************
// * License and Disclaimer                                           *
// *                                                                  *
// * The  Geant4 software  is  copyright of the Copyright Holders  of *
// * the Geant4 Collaboration.  It is provided  under  the terms  and *
// * conditions of the Geant4 Software License,  included in the file *
// * LICENSE and available at  http://cern.ch/geant4/license .  These *
// * include a list of copyright holders.                             *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.  Please see the license in the file  LICENSE  and URL above *
// * for the full disclaimer and the limitation of liability.         *
// *                                                                  *
// * This  code  implementation is the result of  the  scientific and *
// * technical work of the GEANT4 collaboration.                      *
// * By using,  copying,  modifying or  distributing the software (or *
// * any work based  on the software)  you  agree  to acknowledge its *
// * use  in  resulting  scientific  publications,  and indicate your *
// * acceptance of all terms of the Geant4 Software license.          *
// ********************************************************************
//
#ifndef VKDetectorMessenger_h
#define VKDetectorMessenger_h 1

#include "G4UImessenger.hh"
#include "globals.hh"

class VKDetectorConstruction;
class G4UIdirectory;
class G4UIcmdWithADoubleAndUnit;
class G4UIcmdWith3VectorAndUnit;
class G4UIcmdWithAnInteger;
class G4UIcommand;
class G4UIcmdWithABool;
class G4UIcmdWithADouble;
class G4UIcmdWithAString;

class VKDetectorMessenger: public G4UImessenger
{
  public:

    VKDetectorMessenger(VKDetectorConstruction* pDetConstr);
    virtual ~VKDetectorMessenger();
 
    virtual void SetNewValue(G4UIcommand*, G4String);
 
  private:

    VKDetectorConstruction *fDetConstr;
    G4UIdirectory *fDetectorDir;
    G4UIdirectory *fVolumesDir;
    G4UIdirectory *fFieldDir;
    G4UIcmdWithABool *fMagnetCmd;
    G4UIcmdWithABool *fBetaDetectorCmd;
    G4UIcmdWithABool *fBetaDetectorV2Cmd;
    G4UIcmdWithABool *fMuonTelescopeCmd;
    G4UIcmdWithABool *fCatcherFoilCmd;
    G4UIcmdWithABool *fShieldCmd;
    G4UIcmdWithABool *fLeadBlockCmd;
    G4UIcmdWithABool *fBlinkersCmd;
    G4UIcmdWithABool *fVirtualDetectorsCmd;
    G4UIcmdWithABool *fBFieldCmd;
    G4UIcmdWithABool *fCheckOverlapsCmd;
    G4UIcmdWithADoubleAndUnit *fMaxBFieldCmd;
    G4UIcmdWith3VectorAndUnit *fCatcherFoilPositionCmd;
    G4UIcmdWith3VectorAndUnit *fBetaDetectorPositionCmd;
    G4UIcmdWithAString *fCatcherFoilMaterialCmd;
    G4UIcmdWithADoubleAndUnit *fCatcherFoilThicknessCmd;
};

#endif
