//
// ********************************************************************
// * License and Disclaimer                                           *
// *                                                                  *
// * The  Geant4 software  is  copyright of the Copyright Holders  of *
// * the Geant4 Collaboration.  It is provided  under  the terms  and *
// * conditions of the Geant4 Software License,  included in the file *
// * LICENSE and available at  http://cern.ch/geant4/license .  These *
// * include a list of copyright holders.                             *
// *                                                                  *
// * Neither the authors of this software system, nor their employing *
// * institutes,nor the agencies providing financial support for this *
// * work  make  any representation or  warranty, express or implied, *
// * regarding  this  software system or assume any liability for its *
// * use.  Please see the license in the file  LICENSE  and URL above *
// * for the full disclaimer and the limitation of liability.         *
// *                                                                  *
// * This  code  implementation is the result of  the  scientific and *
// * technical work of the GEANT4 collaboration.                      *
// * By using,  copying,  modifying or  distributing the software (or *
// * any work based  on the software)  you  agree  to acknowledge its *
// * use  in  resulting  scientific  publications,  and indicate your *
// * acceptance of all terms of the Geant4 Software license.          *
// ********************************************************************
//
#ifndef VKPrimaryGeneratorMessenger_h
#define VKPrimaryGeneratorMessenger_h 1

#include "G4UImessenger.hh"
#include "globals.hh"

class VKPrimaryGeneratorAction;
class G4UIdirectory;
class G4UIcmdWithADoubleAndUnit;
class G4UIcmdWith3VectorAndUnit;
class G4UIcmdWithAnInteger;
class G4UIcommand;
class G4UIcmdWithABool;
class G4UIcmdWithADouble;
class G4UIcmdWith3Vector;

class VKPrimaryGeneratorMessenger: public G4UImessenger
{
  public:

    VKPrimaryGeneratorMessenger(VKPrimaryGeneratorAction *fPrimGenAct);
    virtual ~VKPrimaryGeneratorMessenger();
 
    virtual void SetNewValue(G4UIcommand*, G4String);
 
  private:

    VKPrimaryGeneratorAction *fPrimGenAct;
    G4UIdirectory *fPrimGenDir;
    G4UIcmdWithABool *fBetaSpectrumCmd;
    G4UIcmdWithABool *fCRMuonAngDistCmd;
    G4UIcmdWithABool *fDiskShapedSourceCmd;
    G4UIcmdWithADoubleAndUnit *fBetaEndPointCmd;
    G4UIcmdWithADoubleAndUnit *fBetaMinEnergyCmd;
    G4UIcmdWithADoubleAndUnit *fBetaMaxEnergyCmd;
    G4UIcmdWithADoubleAndUnit *fMinZenithCmd;
    G4UIcmdWithADoubleAndUnit *fMaxZenithCmd;
    G4UIcmdWithADoubleAndUnit *fInnerDiameterCmd;
    G4UIcmdWithADoubleAndUnit *fOuterDiameterCmd;
    G4UIcmdWith3Vector *fSurfaceNormalCmd;
    G4UIcmdWithADouble *fPowerCmd;
    G4UIcmdWithADouble *fShapeFuncA1Cmd;
    G4UIcmdWithADouble *fShapeFuncA2Cmd;
    G4UIcmdWithADouble *fShapeFuncA3Cmd;
    G4UIcmdWithADouble *fShapeFuncA4Cmd;
    G4UIcmdWithADouble *fShapeFuncA5Cmd;
    G4UIcmdWithADouble *fShapeFuncA6Cmd;
    G4UIcmdWithAnInteger *fBetaZCmd;
    G4UIcmdWithAnInteger *fBetaACmd;
};

#endif
